#include <stdio.h>
#include "main.h"
#include <string.h>

typedef unsigned char u8;

int main(int argc, char* argv[])
{
    u8  input[] = "AAAAAEEEFFFFAAAHHHHJJJJJHHHH";
    int inputSize = strlen((char*)input);
    u8  output[inputSize * 2];
    int outputSize = 0;

    printf("input: %s\n", input);
    printf("input size: %d\n", inputSize);

    int runStart = 0;
    int currentByte = 1;

    while (true)
    {
        int runLength = currentByte - runStart;

        if (input[currentByte] != input[runStart] ||
            currentByte == inputSize ||
            runLength == 255)
        {
            output[outputSize++] = runLength;
            output[outputSize++] = input[runStart];
            runStart = currentByte;
        }

        if (currentByte == inputSize)
            break;

        currentByte++;
    }

    printf("output: ");

    for (int i = 0; i < outputSize; i += 2)
    {
        printf("(%d)", output[i]);
        printf("%c ", output[i + 1]);
    }
    printf("\n");
    printf("output size: %d\n", outputSize);

    return 0;
}
